function[setpoint] = controllerVO_POS(qd,objects,t,param)
%position
Kp = [15;15;30];
Kd = [17;12;10];

%High level control: Anti Collision (Velocity Obstacle)
%TARGET_RADIUS = 0.1;         % Start to break when inside TARGET_RADIUS
sens_rng = 5;
stop = qd.pos_d;

%set to zero
vo_list = []; % Normal VO
%IN 2D
for i=1:length(objects)
    
%dist_to_goal = norm(stop(1:2) -qd.pos(1:2));
dist_to_obst = max(norm(objects(i).pos(1:2) - qd.pos(1:2)) - objects(i).radius, 0);
%Calcualte VO if it senses obstacle
if dist_to_obst <= sens_rng
    vo = calc_cone_VO(qd,objects(i)); %vo is an objects(1)ect:cone
    vo_list = [vo_list vo];
    %sector = radar_sector(objects(1), qd); %yields which radar sector the obstacle is detected in
end
end
% %Calculate VO if wall detected
% %BOTTOM
% if dist_to_bottom <= sens_rng
%     bottom_vo = calc_wall_cone_VO(qd, closest_sp_bottom); 
%     vo_list = [vo_list bottom_vo];
% end
% %TOP
% if dist_to_top <= sens_rng
%     top_vo = calc_wall_cone_VO(qd, closest_sp_top); 
%     vo_list = [vo_list top_vo];
% end
% %WALLS
% for i = 1:length(closest_sps)
%     if dist_to_walls(i) <= sens_rng
%         wall_vo = calc_wall_cone_VO(qd, closest_sps(:,i)); 
%         vo_list = [vo_list wall_vo];
%     end
% end  
% Guidance%%

[qd_yaw_d, qd.vel_d] = VO_guidance(qd, stop); % qd.yaw_d
conflict = 0;
% hold on; 
% if t > 2.3
%     plot_all_vo(vo_list, qd.pos(3), 'b')
%     stop = 1;
% end 

       for kk = 1:size(vo_list,2)
           if vo_list(kk).is_inside(qd.pos, qd.vel_d(1:2))
              conflict = 1;
           end
       end
% If Vd in VOs
% Find v' that is outside VO and closes to Vd, within velocity restrictions
if conflict && t > 0.1
    %error in choose new v, stops animation as well, this has been fixed by
    %restriction in the ODE45 function
       new_v = choose_new_v(qd, vo_list);
       qd.vel_d = [new_v(1); new_v(2); qd.vel_d(3)];
       qd.pos_d = qd.pos + qd.vel_d;
else
    desired_state = step(t);

    % The desired_state is set in the trajectory generator
    qd.pos_d      = desired_state.pos;
    qd.vel_d      = desired_state.vel;
    qd.acc_d      = desired_state.acc;
    qd.yaw_d      = desired_state.yaw;
    qd.yawDot_d   = desired_state.yawDot;
end
%hold on; plot3(qd.pos_d(1), qd.pos_d(2), qd.pos_d(3), '*');



%PID Low level control: Desired acceleration
% The acc_d is supposed to be given from the colav algorithm
% Position (pos_d) comes indirectly from the desired velocity (vel_d) and a time delay appears 
acc_d = qd.acc_d + Kd.*(qd.vel_d - qd.vel) + Kp.*(qd.pos_d - qd.pos);

%roll, pitch, yaw
phi_d = sat(1/param.grav*(acc_d(1)*sin(qd.yaw_d)-acc_d(2)*cos(qd.yaw_d)),(45*pi/180));
theta_d = sat(1/param.grav*(acc_d(1)*cos(qd.yaw_d)+acc_d(2)*sin(qd.yaw_d)),(45*pi/180));
psi_d = qd.yaw_d;

euler_d = [phi_d; theta_d; psi_d];
setpoint = [euler_d; acc_d(3)];  

end