function filteredVel = refFilter(pos, vel, acc, jerk)
w0 = 3;  %omega_0
xi = 1;  %zeta

ref   = pos;   %reference value x_d(step)
v_lim = 3;    %velocity limit
a_lim = 1.5;  %acceleration limit
j_lim = 3;

%PARAMETERS
k4_4 = (4*xi)*w0;
k3_4 = k4_4\(2 + 4*xi^2)*w0^2;
k2_4 = (k4_4*k3_4)\((4*xi)*w0^3);
k1_4 = (k4_4*k3_4*k2_4)\w0^4;
%FILTER
tau1 = k1_4 * (ref - pos);
if norm(tau1) > v_lim
        tau1 = v_lim * tau1 / norm(tau1); 
end
tau2 = k2_4 * (tau1 - vel);
if norm(tau2) > a_lim
        tau2 = a_lim * tau2 / norm(tau2);
end
tau3 = k3_4 * (tau2 - acc);
if norm(tau3) > j_lim
        tau3 = j_lim * tau3 / norm(tau3);
end
filteredVel = k4_4 * (tau3 - jerk);

end
