%Create obstacles

b = Box([0;0;0], [20;0;0], [20;0;5], 1);
        %First corner, second, third, depth
        
s = Sphere([5;5;5], 2);
        %center, radius

c = Cylinder([15; 1; 2], [15;5;3], 1);
             %Center of bottom, center of top, radius
             
p = [1; 4; 10]; %Point in space


distanceToBox = b.distanceTo(p);
distanceToCylinder = c.distanceTo(p);
distanceToSphere = s.distanceTo(p);

closestPointOnBox = b.closestSurfacePointTo(p);
closestPointOnCylinder = c.closestSurfacePointTo(p);
closestPointOnSphere = s.closestSurfacePointTo(p);

points = [closestPointOnBox closestPointOnCylinder closestPointOnSphere];
lines = [p closestPointOnBox p closestPointOnCylinder p closestPointOnSphere];

f = figure();
grid on;
hold on;
b.draw();
s.draw();
c.draw();

scatter3(p(1), p(2), p(3), 'filled'); %Draw the point in space
scatter3(points(1,:), points(2,:), points(3,:), 'filled'); %Draw closest points on surfaces
%Plot lines from point to surfaces
plot3([p(1) closestPointOnBox(1)], [p(2) closestPointOnBox(2)], [p(3) closestPointOnBox(3)]);
plot3([p(1) closestPointOnSphere(1)], [p(2) closestPointOnSphere(2)], [p(3) closestPointOnSphere(3)]);
plot3([p(1) closestPointOnCylinder(1)], [p(2) closestPointOnCylinder(2)], [p(3) closestPointOnCylinder(3)]);

axis = [-1 25; -5 10; -1 10];
xlim(axis(1,:));
ylim(axis(2,:));
zlim(axis(3,:));

view([-145 20]);