function Vnew = choose_new_v(agent, vo_list)
% Find new velocity outside vo and as close as possible to [speed_d, psi_d] 
cur_pos = agent.pos;
cur_V = agent.vel(1:2);
cur_psi = vector_ang(cur_V(1), cur_V(2));
speed = norm(cur_V);
Vmax = 5; % Should be param.maxV
Vmin = 0;


% Make a set of N v's that is within acc and yaw_max constraints. 
psi_delta = 0.2;   % 0.1
psi_range = 1.5;     % 1.5
speed_delta = 0.1; % 0.1
speed_range = 1; % 2
%list of possible Velocity candidates
a_list = find_V_candidates(psi_range, psi_delta, speed_range, speed_delta, vo_list, cur_pos, cur_psi, speed, Vmin, Vmax);

% if isempty(a_list)
%     psi_delta = 0.05; psi_range = 1.5;
%     speed_delta = 0.1; 
%     speed_range = 1;
%     a_list = find_V_candidates(psi_range, psi_delta, speed_range, speed_delta, vo_list, cur_pos, cur_psi, speed, Vmin, 0.6*Vmax);
% end
% 
% if isempty(a_list)
%    % Do a more crude search for new V here 
%     psi_delta = 0.15; psi_range = 2;
%     speed_delta = 0.2; 
%     speed_range = 1.5;
%     a_list = find_V_candidates(psi_range, psi_delta, speed_range, speed_delta, vo_list, cur_pos, cur_psi, speed, Vmin, Vmin+0.1);
% end


% if isempty(a_list)
%     %disp('a_list er tom i find_best_velo()')
%     %plot_all_velo_candidates(current_position, b_list, 'c')
%     last_r = 1;
%     if last_r > 0
%         [Vx, Vy] = pol2cart(cur_psi + 0.2, Vmin);
%     else
%         [Vx, Vy] = pol2cart(cur_psi - 0.2, Vmin);
%     end
%     a_list = [Vx; Vy];
%     
%     % Prve  se om jeg kan regne ut time to collision i stedet
% end


% Choose Vnew closest to agent.vel_d among candidates
%hold on; plot_all_velo_candidates(cur_pos, a_list,'m', 1);
try
 V_cand = a_list - agent.vel_d(1:2);
catch
    stttttoop = 1;
end
mag = Inf;
index = 0;
for k = 1:size(a_list,2)
    Vlen = norm(V_cand(:,k));
    if Vlen < mag
        index = k;
        mag = Vlen;
        Vlist = a_list(:,k);
    elseif Vlen == mag
        Vlist = [Vlist a_list(:,k)];
    end
end

% Choose to turn most rightwards if there are more V candidates
Vnew = Vlist(:,1);
minAng = Inf; 
for kk = 2:size(Vlist,2)
    v2 = Vlist(:,kk);
    angle = atan2(cur_V(2),cur_V(1)) - atan2(v2(2),v2(1));
    if abs(angle) > pi
        angle = angle - 2*pi*sign(angle);
    end

    if angle < minAng
        minAng = angle;
        Vnew = Vlist(:,kk);
    end
end

%plot_all_velo_candidates(cur_pos, Vnew, 'g', 3)
%stoooop = 1;
end